package edu.ksu.cis.ndpc;

/**
 * @author Brian Mulanda
 *
 */

import edu.ksu.cis.viewer.TreeDrawing;
import java.awt.Dimension;
import javax.swing.JScrollPane;
import javax.swing.JFrame;
import javax.swing.Box;
import javax.swing.JComponent;

public class ProofTreeViewer {
	private JScrollPane pane;

	public static void main(String[] arg) {
		new ProofTreeViewer();
	}

	public ProofTreeViewer() {
		JFrame frame = new JFrame("PPL Proof Tree Viewer");
		frame.getContentPane().add(init());
		frame.pack();
		// frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setLocation(300, 300);
		frame.setVisible(true);
	}

	private JComponent init() {
		pane = new JScrollPane();
		pane.setPreferredSize(new Dimension(200, 300));
		Box b = Box.createVerticalBox();
		b.setAlignmentY(Box.LEFT_ALIGNMENT);
		b.add(pane);
		return b;
	}

	public void viewTree(ProofTree tree) {
		JComponent drawing = null;
		if (tree != null) {
			drawing = (new TreeDrawing(tree, 100)).getDrawing();
		} else {
		}
		pane.setViewportView(drawing);
	}
}
