package edu.ksu.cis.ndpc.gui;

public class Row {
	private StringBuffer r;

	private static int lpad = 0;
	private static int rpad = 0;
	private static int tpad = 0;
	private static int bpad = 0;
	private static int ascent = 7;
	private static int height = computeHeight();

	public Row() {
		r = new StringBuffer("");
	}

	public static int getLPad() {
		return lpad;
	}

	public static int getRPad() {
		return rpad;
	}

	public static int getTPad() {
		return tpad;
	}

	public static int getBPad() {
		return bpad;
	}

	public static int getAscent() {
		return ascent;
	}

	public static int getHeight() {
		return height;
	}

	public static void setLPad(int value) {
		lpad = value;
		height = computeHeight();
	}

	public static void setRPad(int value) {
		rpad = value;
		height = computeHeight();
	}

	public static void setTPad(int value) {
		tpad = value;
		height = computeHeight();
	}

	public static void setBPad(int value) {
		bpad = value;
		height = computeHeight();
	}

	public static void setAscent(int value) {
		ascent = value;
		height = computeHeight();
	}

	private static int computeHeight() {
		return tpad + bpad + ascent;
	}

	public int length() {
		return length(false);
	}

	public int length(boolean trim) {
		if (trim) {
			return r.toString().trim().length();
		} else {
			return r.length();
		}
	}

	public void append(char c) {
		r.append(c);
	}

	public void append(char[] c) {
		r.append(c);
	}

	public void append(String s) {
		r.append(s);
	}

	public void insert(int offset, char c) {
		r.insert(offset, c);
	}

	public char[] getData() {
		return r.toString().toCharArray();
	}

	public void setData(char c) {
		r.setLength(0);
		r.append(c);
	}

	public void setData(char[] c) {
		r.setLength(0);
		r.append(c);
	}

	public void setData(String s) {
		r.setLength(0);
		r.append(s);
	}

	public void deleteCharAt(int index) {
		r.deleteCharAt(index);
	}

	public void deleteAll() {
		r.setLength(0);
	}

	public void deleteRest(int start) {
		r.delete(start, Integer.MAX_VALUE);
	}

	public void delete(int start, int end) {
		r.delete(start, end);
	}

	public char[] subchars(int start) {
		char[] chars = new char[r.length() - start];
		r.getChars(start, r.length(), chars, 0);
		return chars;
	}

	public char[] subchars(int start, int end) {
		int count = end - start + 1;
		char[] chars = new char[count];
		r.getChars(start, end + 1, chars, 0);
		return chars;
	}

	public String substring(int start, int end) {
		if (start >= end || end > r.length()) {
			return "";
		} else {
			return r.substring(start, end);
		}
	}

	public String substring(int start) {
		return r.substring(start);
	}

	public String toString() {
		return r.toString();
	}
}