package edu.ksu.cis.ndpc.rules;

import edu.ksu.cis.ndpc.LangSymbols;
import edu.ksu.cis.ndpc.ProofStatement;
import edu.ksu.cis.ndpc.Symbol;

/**
 * @author Brian Mulanda
 * 
 */

public final class RuleBottomElim extends Rule {
	private static String name = getDescription(Rule.BOTTOM_ELIM);

	public RuleBottomElim() {
		super();
	}

	public int getType() {
		return Rule.BOTTOM_ELIM;
	}

	public void check(RuleParameter[] params) throws RuleException {
		if (params == null || params.length != 2 || params[0] == null
				|| params[1] == null) {
			throw new RuleException("Rule requires a formula");
		} else if (!((params[0] instanceof ProofStatement) && (params[1] instanceof ProofStatement))) {
			throw new RuleException("Rule requires a formula");
		}

		ProofStatement premise = (ProofStatement) params[0];

		Symbol root = premise.getFormula().getParseTree().getRootNode();
		if (root.getType() != LangSymbols.S_BOTTOM) {
			throw new RuleException("Formula " + premise
					+ " must have '_|_' as its main connective");
		}
	}
}