package edu.ksu.cis.ndpc.rules;

import edu.ksu.cis.ndpc.ProofStatement;

/**
 * @author Brian Mulanda
 * 
 */

public final class RuleCOPY extends Rule {
	private static String name = getDescription(Rule.COPY);

	public RuleCOPY() {
		super();
	}

	public int getType() {
		return Rule.COPY;
	}

	public void check(RuleParameter[] params) throws RuleException {
		if (params == null || params.length != 2 || params[0] == null
				|| params[1] == null) {
			throw new RuleException("Rule requires a formula");
		} else if (!((params[0] instanceof ProofStatement) && (params[1] instanceof ProofStatement))) {
			throw new RuleException("Rule requires a formula");
		}

		ProofStatement premise = (ProofStatement) params[0];
		ProofStatement conclusion = (ProofStatement) params[1];

		if (!premise.getFormula().getParseTree().equals(
				conclusion.getFormula().getParseTree())) {
			throw new RuleException("Formula " + premise
					+ " must be the same as " + "formula " + conclusion);
		}
	}
}